// ATITVOExtensions.c
//////////////////////////////////////////////////////////////////////////////


// extension protocoll defines
#define XREP_SZ(name)       sizeof(x##name##Reply)
#define XREQ_SZ(name)       sizeof(x##name##Req)


// includes

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xproto.h>
#include <X11/Xlibint.h>
#include <X11/extensions/XTest.h>
#include <X11/extensions/sync.h>
#include <X11/Xproto.h>
#include <X11/extensions/Xdbe.h>
#include <X11/extensions/record.h>
#include <X11/extensions/shape.h>

#include <X11/extensions/xf86misc.h>
#include <X11/extensions/xf86mscstr.h>
#include "extutil.h"

#include <X11/extensions/XInput.h>

#include <X11/Xos.h>
#include <stdio.h>
#include <stdlib.h>

#include "ATITVOExtensions.h"
#include "atiddx_extension_tvout.h"

static XExtensionInfo _atitvo_info_data;
static XExtensionInfo *atitvo_info = &_atitvo_info_data;
static char *atitvo_extension_name = ATITVOUT_EXTENSION_NAME;


//////////////////////////////////////////////////////////////////////////////
// private functions

XExtDisplayInfo *info;

// X shutdown hook function that will cleanup the opened extension
static XEXT_GENERATE_CLOSE_DISPLAY (close_display_atitvo, 
                                    atitvo_info)

// table with X hooks
static /* const */ XExtensionHooks atitvo_extension_hooks = {
    NULL,                   /* create_gc */
    NULL,                   /* copy_gc */
    NULL,                   /* flush_gc */
    NULL,                   /* free_gc */
    NULL,                   /* create_font */
    NULL,                   /* free_font */
    close_display_atitvo,   /* close_display */
    NULL,                   /* wire_to_event */
    NULL,                   /* event_to_wire */
    NULL,                   /* error */
    NULL,                   /* error_string */
};

// find_display_atitvo - get the display info block for atitvo extension
static XEXT_GENERATE_FIND_DISPLAY (find_display_atitvo, 
                                   atitvo_info,
                                   atitvo_extension_name, 
                                   &atitvo_extension_hooks, 
                                   ATITVOUT_NUMBER_EVENTS, 
                                   NULL)



static int 
answerisyes(char *s)
{
    if (s[0] == '\'')   /* For fools that type the ' literally. */
        return tolower(s[1]) == 'y';
    return tolower(s[0]) == 'y';
}


static void 
getstring(char *s)
{
    char *cp;
    fgets(s, 80, stdin);
    cp = strchr(s, '\n');
    if (cp)
        *cp=0;
}



//////////////////////////////////////////////////////////////////////////////
// type defines

typedef unsigned long DWORD;
typedef unsigned long ULONG;
typedef unsigned int HANDLE;
#ifndef ULONG_PTR
typedef ULONG ULONG_PTR;
#endif // ULONG_PTR


//////////////////////////////////////////////////////////////////////////////
// macro defines

// debug

#ifdef DEBUG
#define DEB(s)  s
#else
#define DEB(s)
#endif // DEBUG


#ifdef DEBUG
#define TRACE_XEXT(fmt, arg...)     printf("[FGLRXExtensions] " fmt, ##arg)
#else
#define TRACE_XEXT(fmt, arg...)     do { /* empty */ } while(0)
#endif // DEBUG

// misc

#define FALSE   (1==0)
#define TRUE    (1==1)


//TBD: This code is no longer applicable and this file should be removed in the future!!!
//     Please use the tvout extension loacated in /extensions/tvout/lib/

/*****************************************************************************/
/*                                                                           */
/* NAME:      ExtATITVOEnableDisable                                         */
/*                                                                           */
/* FUNCTION:                                                                 */
/*                                                                           */
/* INPUT:     Display *dpy                                                   */
/*            int iTVStd                                                     */
/*                                                                           */
/*                                                                           */
/* OUTPUTS:                                                                  */
/*                                                                           */
/* NOTE:                                                                     */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
Bool ExtATITVOEnableDisable(int iOn)
{
    return FALSE;
} // === ExtATITVOEnableDisable ===

/*****************************************************************************/
/*                                                                           */
/* NAME:      ExtATITVOSetTVStd                                              */
/*                                                                           */
/* FUNCTION:                                                                 */
/*                                                                           */
/* INPUT:     Display *dpy                                                   */
/*            int iTVStd                                                     */
/*                                                                           */
/*                                                                           */
/* OUTPUTS:                                                                  */
/*                                                                           */
/* NOTE:                                                                     */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
Bool ExtATITVOSetTVStd(int iTVStd)
{
    return FALSE;
} // === ExtATITVOSetTVStd ===

/*****************************************************************************/
/*                                                                           */
/* NAME:      ExtATITVOGetData                                               */
/*                                                                           */
/* FUNCTION:                                                                 */
/*                                                                           */
/* INPUT:                                                                    */
/*            ATITVOGetDataPtr pATITVOGetData                                */
/*                                                                           */
/*                                                                           */
/* OUTPUTS:                                                                  */
/*                                                                           */
/* NOTE:                                                                     */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
Bool ExtATITVOGetData(ATITVOGetDataPtr pATITVOGetData)
{
    return FALSE;
} // === ExtATITVOGetData ===


/*****************************************************************************/
/*                                                                           */
/* NAME:      ExtATITVOAdjustSize                                            */
/*                                                                           */
/* FUNCTION:                                                                 */
/*                                                                           */
/* INPUT:                                                                    */
/*                                                                           */
/*                                                                           */
/* OUTPUTS:                                                                  */
/*                                                                           */
/* NOTE:                                                                     */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
Bool ExtATITVOAdjustSize(ATITVOExtAdjustSizePtr pATITVOExtAdjustSize)
{
    return FALSE;
} // === ExtATITVOAdjustSize ===


/*****************************************************************************/
/*                                                                           */
/* NAME:      ExtATITVOAdjustPosition                                        */
/*                                                                           */
/* FUNCTION:                                                                 */
/*                                                                           */
/* INPUT:                                                                    */
/*                                                                           */
/*                                                                           */
/* OUTPUTS:                                                                  */
/*                                                                           */
/* NOTE:                                                                     */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
Bool ExtATITVOAdjustPosition(ATITVOAdjustPositionPtr pATITVOAdjustPosition)
{
    return FALSE;
} // === ExtATITVOAdjustPosition ===

/*****************************************************************************/
/*                                                                           */
/* NAME:      ExtATITVOAdjustColor                                           */
/*                                                                           */
/* FUNCTION:                                                                 */
/*                                                                           */
/* INPUT:                                                                    */
/*                                                                           */
/*                                                                           */
/* OUTPUTS:                                                                  */
/*                                                                           */
/* NOTE:                                                                     */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
Bool ExtATITVOAdjustColor(int itvColorAdj)
{
    return FALSE;
} // === ExtATITVOAdjustColor ===

/*****************************************************************************/
/*                                                                           */
/* NAME:      ExtATITVOSetData                                               */
/*                                                                           */
/* FUNCTION:                                                                 */
/*                                                                           */
/* INPUT:                                                                    */
/*            ATITVOGetDataPtr pATITVOGetData                                */
/*                                                                           */
/*                                                                           */
/* OUTPUTS:                                                                  */
/*                                                                           */
/* NOTE:                                                                     */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
Bool ExtATITVOSetData(ATITVOGetDataPtr pATITVOGetData)
{
    return FALSE;
} // === ExtATITVOSetData ===




